//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 Red
#property indicator_width1 2

//
//
//
//
//

extern int  Price  = PRICE_MEDIAN;
extern bool Smooth = true;

//
//
//
//
//

double detrend[];
double signal[];
double work[][3];

//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,detrend);
   SetIndexBuffer(1,signal);
      IndicatorShortName("iDetrend");
 return (0);
}
  
//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//
//
//
//
//

int start()
{    
   int countedBars = IndicatorCounted();
   int i,r,limit;

   if(countedBars < 0) {return (-1);}
   if(countedBars > 0) {countedBars--;}
           limit = MathMin(Bars-countedBars-1,Bars-1);
           if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

   for(i = limit, r=Bars-i-1; i >= 0; i--, r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
            
         work[r][0] = price + 0.088*work[r-6][0];
         work[r][1] = work[r][0] - work[r-6][0] + 1.2*work[r-6][1] - 0.7*work[r-12][1];
         work[r][2] = work[r][1] - 2.0*work[r-6][1] + work[r-12][1];

         if (Smooth)
               detrend[i] = iOptimumEllipticFilter(work[r][2],i);
         else  detrend[i] = work[r][2];
         signal[i]  = detrend[i+1];
   }
   return (0);  
}


//+-------------------------------------------------------------------+
//|                                                                   |
//+-------------------------------------------------------------------+
//
//
//
//
//

double   ioeWork[][2];
#define _ioePrice  0
#define _ioeSmooth 1

//
//
//
//
//

double iOptimumEllipticFilter(double price, int i)
{
   if (ArrayRange(ioeWork,0)!=Bars) ArrayResize(ioeWork,Bars);
   
   int r = Bars-i-1;
      ioeWork[r][_ioePrice]  = price;
      ioeWork[r][_ioeSmooth] = 0.13785*(2.0*ioeWork[r  ][_ioePrice] - ioeWork[r-1][_ioePrice]) +
                               0.0007 *(2.0*ioeWork[r-1][_ioePrice] - ioeWork[r-2][_ioePrice]) +
                               0.13785*(2.0*ioeWork[r-2][_ioePrice] - ioeWork[r-3][_ioePrice]) + 
                               1.2103*ioeWork[r-1][_ioeSmooth] - 0.4867*ioeWork[r-2][_ioeSmooth];
   return(ioeWork[r][_ioeSmooth]);
}